window.Gleam.initSearch([{"doc":"gacache","title":"gacache","content":"# gacache\n\n[![Package Version](https://img.shields.io/hexpm/v/gacache)](https://hex.pm/packages/gacache)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gacache/)\n\n```sh\ngleam add gacache@1\n```\n```gleam\nimport gacache\nimport gleam/io\n\npub fn main() {\n  // Start a cache\n  let assert Ok(cache) = gacache.start() // Starts the cache\n  gacache.set(cache, &quot;test&quot;, &quot;val&quot;) // Set a value\n  gacache.set(cache, &quot;funky&quot;, &quot;1&quot;) // Set a value\n  let _ = io.debug(gacache.get(cache, &quot;test&quot;))// Ok(&quot;val&quot;) | The value bound to the key\n  io.debug(gacache.keys(cache)) // [&quot;funky&quot;, &quot;test&quot;] | All keys in the map\n  gacache.stop(cache) // Stops the cache\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gacache&gt;.\n","url":"index.html"},{"doc":"gacache","title":"Action","content":"pub type Action(value) {\n  Set(key: Key, value: value)\n  Get(ret: process.Subject(Result(value, Error)), key: Key)\n  Clear(key: Key)\n  Keys(ret: process.Subject(List(Key)))\n  Reset\n  Raw(ret: process.Subject(Store(value)))\n  Merge(store: Store(value))\n  Stop\n}\n Actions are passed to the Cache to interact with it&#39;s Store\nSet(key: Key, value: value)\n\n\nGet(ret: process.Subject(Result(value, Error)), key: Key)\n\n\nClear(key: Key)\n\n\nKeys(ret: process.Subject(List(Key)))\n\n\nReset\n\n\nRaw(ret: process.Subject(Store(value)))\n\n\nMerge(store: Store(value))\n\n\nStop\n\n\nSynonyms:\ngacache.Action\ngacache Action","url":"gacache.html#Action"},{"doc":"gacache","title":"Error","content":"pub type Error {\n  NotCached\n  Timeout\n}\n\nNotCached\n Provided when the Get Action is sent with a Key that has no corresponding Value\n\nTimeout\n Provided when either a Get or Raw Action cannot be completed in 10 seconds\n\nSynonyms:\ngacache.Error\ngacache Error","url":"gacache.html#Error"},{"doc":"gacache","title":"clear","content":"pub fn clear(cache: Subject(Action(a)), key: String) -&gt; Nil\n Removes the Value associated with the provided Key from the Store\nSynonyms:\ngacache.clear\ngacache clear","url":"gacache.html#clear"},{"doc":"gacache","title":"get","content":"pub fn get(\n  cache: Subject(Action(a)),\n  key: String,\n) -&gt; Result(a, Error)\n\nSynonyms:\ngacache.get\ngacache get","url":"gacache.html#get"},{"doc":"gacache","title":"keys","content":"pub fn keys(cache: Subject(Action(a))) -&gt; List(String)\n Returns all keys known by the Store\nSynonyms:\ngacache.keys\ngacache keys","url":"gacache.html#keys"},{"doc":"gacache","title":"merge","content":"pub fn merge(\n  cache: Subject(Action(a)),\n  new_store: Dict(String, a),\n) -&gt; Nil\n Merges the Store with the provided Store using dict:merge/2\nSynonyms:\ngacache.merge\ngacache merge","url":"gacache.html#merge"},{"doc":"gacache","title":"raw","content":"pub fn raw(\n  cache: Subject(Action(a)),\n) -&gt; Result(Dict(String, a), Error)\n Returns the Store, avoid if possible\nSynonyms:\ngacache.raw\ngacache raw","url":"gacache.html#raw"},{"doc":"gacache","title":"reset","content":"pub fn reset(cache: Subject(Action(a))) -&gt; Nil\n Clears the whole Store\nSynonyms:\ngacache.reset\ngacache reset","url":"gacache.html#reset"},{"doc":"gacache","title":"set","content":"pub fn set(\n  cache: Subject(Action(a)),\n  key: String,\n  value: a,\n) -&gt; Nil\n Updates the Store with key=value\nSynonyms:\ngacache.set\ngacache set","url":"gacache.html#set"},{"doc":"gacache","title":"start","content":"pub fn start() -&gt; Result(Subject(Action(a)), StartError)\n Start the cache\nSynonyms:\ngacache.start\ngacache start","url":"gacache.html#start"},{"doc":"gacache","title":"stop","content":"pub fn stop(cache: Subject(Action(a))) -&gt; Nil\n Stops the cache\nSynonyms:\ngacache.stop\ngacache stop","url":"gacache.html#stop"},{"doc":"gacache","title":"gacache","content":"","url":"gacache.html"}]);